package com.wizarpos.cloudposscannerdemo.UI;

import android.content.Context;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.wizarpos.cloudposscannerdemo.R;

import java.util.Locale;

/**
 * Created by gecx on 16-12-5.
 */

public class ListViewAdapter extends BaseAdapter {

    private final String[] data;
    private Context mContext;

    public ListViewAdapter(Context context) {
        mContext = context;
        Locale locale = context.getResources().getConfiguration().locale;
        String language = locale.getLanguage();
        if (language.endsWith("zh")) {
            data = new String[]{"同步扫码", "异步扫码", "扫码窗口非全屏", "扫码返回图片", "去掉扫码框,全屏扫码",
                    "只扫二维码和Code128码", "自定义扫码框"};
        } else {
            data = new String[]{"Synchronous Scan", "Asynchronous Scan", "Not full screen", "Return bitmap", "full screen",
                    "only QR or code128", "custom window"};
        }
    }

    @Override
    public int getCount() {
        return data.length;
    }

    @Override
    public Object getItem(int position) {
        return data[position];
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        ViewHolder holder;
        if (convertView == null) {
            convertView = View.inflate(mContext, R.layout.listview_item, null);
            holder = new ViewHolder();
            holder.mTv = (TextView) convertView.findViewById(R.id.tv_item);
            convertView.setTag(holder);
        } else {
            holder = (ViewHolder) convertView.getTag();
        }

        holder.mTv.setText(data[position]);

        return convertView;
    }

    private class ViewHolder {
        private TextView mTv;
    }
}
